
# Przykładowe kod i dane współtowarzyszące książce "Język R i analiza danych w praktyce. Wydanie II" autorstwa Niny Zumel i Johna Mounta, Helion 2021.


* Książka (wersja angielska): ["Practical Data Science with R, 2nd Edition" autorstwa Niny Zumel i Johna Mounta, Manning 2019](http://practicaldatascience.com/) (prawa autorskie należą do wydawnictwa Manning Publications Co.; wszystkie prawa zastrzeżone)
 * Strona z materiałami dodatkowymi (wersja oryginalna): [GitHub WinVector/PDSwR2](https://github.com/WinVector/PDSwR2)


## Fragment książki, dla którego przeznaczone są zawarte w tym katalogu kod i dane:
 * Rozdział 9. Metody nienadzorowane


## Pierwotne dane: 
Zestaw danych Book-Crossing został zebrany przez Cai-Nicolasa Zieglera; pierwotny odnośnik
DBIS Freiburg: http://www.informatik.uni-freiburg.de/~cziegler/BX/

Dane zebrane przez Cai-Nicolasa Zieglera w ciągu czterech tygodni (na przełomie sierpnia i września
2004 r.) ze społeczności bookcrossingowych za uprzejmym przyzwoleniem Rona
Hornbakera, dykrektora działu informatycznego w firmie Humankind Systems. Zawierają 278 858 użytkowników
(anonimizowanych, ale niepozbawionych informacji demograficznych) i 1 149 780
opinii (jawnych / niejawnych) o mniej więcej 271 379 książkach.

Dane te są dostępne bezpłatnie do badań pod warunkiem, że zostanie
umieszczone następujące odniesienie (szczegóły zestawu danych zostały
opisane w tej publikacji): 

Improving Recommendation Lists Through Topic
Diversification, Cai-Nicolas Ziegler, Sean M. McNee, Joseph
A. Konstan, Georg Lausen; Proceedings of the 14th International World
Wide Web Conference (WWW '05), May 10-14, 2005, Chiba, Japan. To
appear.

http://www.informatik.uni-freiburg.de/~cziegler/BX/WWW-2005-Preprint.pdf


## Prace pochodne (nieobjęte licencją):

 * bxBooks.RData     : Dostosowana do R binarna wersja zestawu danych Book-Crossing.
 * bookdata.tsv.gz   : Skompresowany i rozdzielony tabulatorami plik zawierający opinie o książkach, uszeregowane zgodnie z tytułami i oceną numeryczną.

## Nasze dodatkowe dokumentacja, uwagi, kod i dane przykładowe: 

<a rel="license" href="https://creativecommons.org/licenses/by-nc-sa/4.0/deed.pl"><img alt="Licencja Creative Commons" style="border-width:0" src="http://i.creativecommons.org/l/by-nc-sa/4.0/88x31.png" /></a><br />Dzieło to objęte licencją <a rel="license" href="https://creativecommons.org/licenses/by-nc-sa/4.0/deed.pl">Uznanie autorstwa-Użycie niekomercyjne-Na tych samych warunkach 4.0 Międzynarodowe</a>.

 * read_bookcrossing.R   : skrypt odczytujący pierwotne pliki danych i tworzący plik bxBooks.RData
 * create_bookdata.R     : skrypt tworzący plik danych bookdata.tsv



