

# Przykładowe kod i dane współtowarzyszące książce "Język R i analiza danych w praktyce. Wydanie II" autorstwa Niny Zumel i Johna Mounta, Helion 2021.


* Książka (wersja angielska): ["Practical Data Science with R, 2nd Edition" autorstwa Niny Zumel i Johna Mounta, Manning 2019](http://practicaldatascience.com/) (prawa autorskie należą do wydawnictwa Manning Publications Co.; wszystkie prawa zastrzeżone)
 * Strona z materiałami dodatkowymi (wersja oryginalna): [GitHub WinVector/PDSwR2](https://github.com/WinVector/PDSwR2)


## Fragment książki, dla którego przeznaczone są zawarte w tym katalogu kod i dane:
 * Rozdział 7. Regresja liniowa i logistyczna
 * Rozdział 10. Zaawansowane metody uczenia maszynowego
 * Rozdział 11. Dokumentowanie i wdrażanie


### Dane


Dane zostały pierwotnie pobrane dnia 25.04.2013r. ze strony [http://www.cdc.gov/nchs/data_access/Vitalstatsonline.htm](http://www.cdc.gov/nchs/data_access/Vitalstatsonline.htm)

 * [ftp://ftp.cdc.gov/pub/Health_Statistics/NCHS/Dataset_Documentation/DVS/natality/UserGuide2010.pdf](ftp://ftp.cdc.gov/pub/Health_Statistics/NCHS/Dataset_Documentation/DVS/natality/UserGuide2010.pdf)
 * Shasum: 12520b8384defc63a93fad957936fd7ee9a42ef3  UserGuide2010.pdf
 * [ftp://ftp.cdc.gov/pub/Health_Statistics/NCHS/Datasets/DVS/natality/Nat2010us.zip](ftp://ftp.cdc.gov/pub/Health_Statistics/NCHS/Datasets/DVS/natality/Nat2010us.zip)
 * Shasum: dad8b9fc9e8b4a4d250b7febf10d4b97350e2651  Nat2010us.zip

Pliki:

 * CZYTAJ.html : niniejszy dokument
 * CZYTAJ.md : niniejszy dokument
 * UserGuide2010.pdf : pierwotny podręcznik użytkownika z agencji CDC
 * NatalBirthData.rData : przygotowane zachowane dane w formacie R (wygenerowane za pomocą pliku PrzygDanychWagaNoworod.R)
 * NatalRiskData.rData : przygotowane zachowane dane w formacie R (wygenerowane za pomocą pliku PrzygDanychRyzykoPolog.R)
 * PrzygDanychWagaNoworod.R : Etapy przygotowania danych masy urodzeniowej z pliku natal2010Proba.tsv.gz
 * PrzygDanychRyzykoPolog.R : Etapy przygotowania danych ryzyka związanego z porodem z pliku natal2010Proba.tsv.gz
 * gamWykresySklejane.R : przykładowe wykresy
 * natal2010Proba.tsv.gz : próba jednostajna danych zagrożeń związanych z porodem, skompresowanych w formacie TSV (jest ona wygenerowana za pomocą procedur umieszczonych w katalogu Przyklad) 
 * Przyklad : szczegółowe procedury używane do przygotowania danych


## Licencja obejmująca dodatkowe dokumentację, uwagi, kod i dane pochodne: 

<a rel="license" href="https://creativecommons.org/licenses/by-nc-sa/4.0/deed.pl"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-nc-sa/4.0/88x31.png" /></a><br />Niniejsze dzieło jest objęte licencją <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/">Uznanie autorstwa - Użycie niekomercyjne - Na tych samych warunkach 4.0 Międzynarodowe</a>.

Żaden z tych elementów nie jest objęty gwarancją, ubezpieczeniem ani roszczeniem działania.

Licencja nie obejmuje projektów osób trzecich ani danych pochodnych.
