

# Przykładowe kod i dane współtowarzyszące książce "Język R i analiza danych w praktyce. Wydanie II" autorstwa Niny Zumel i Johna Mounta, Helion 2021.


* Książka (wersja angielska): ["Practical Data Science with R, 2nd Edition" autorstwa Niny Zumel i Johna Mounta, Manning 2019](http://practicaldatascience.com/) (prawa autorskie należą do wydawnictwa Manning Publications Co.; wszystkie prawa zastrzeżone)
 * Strona z materiałami dodatkowymi (wersja oryginalna): [GitHub WinVector/PDSwR2](https://github.com/WinVector/PDSwR2)


## Fragment książki, dla którego przeznaczone są zawarte w tym katalogu kod i dane:

  * Rozdział 2. Wprowadzenie do języka R i danych
  * Rozdział 7. Regresja liniowa i logistyczna
  * Rozdział 10. Zaawansowane metody uczenia maszynowego
  * Dodatek A. Korzystanie z R i innych narzędzi


### Niniejsze dane pochodzą z zestawu Public Use Microdata Sample (PUMS) utworzonego w 2016 r. na potrzeby środowiskowych badań społecznych w Stanach Zjednoczonych (US Census American Community Survay - ACS)

  * https://www.census.gov/data/developers/data-sets/acs-1year.2016.html
  * https://www2.census.gov/acs2016_1yr/pums/
  

Zawartość katalogu:

  * CZYTAJ.md : ten dokument
  * ACS2016_PUMS_README.pdf : dokumentacja z urzędu cenzusowego.
  * PUMSDataDict16.txt : słownik danych tekstowych z urzędu cenzusowego.
  * data_dict.csv : słownik danych przekształcony w tabelę wysoką.
  * download : katalog zawierający skrypty służące do pobieranie, losowania i kodowania danych urzędu cenzusowego.
  * PUMSsample.RDS : przykładowa ważona próba rekordów gospodarstw domowych i ich mieszkańców.
  * PUMS1.Rmd : Fragment próby spisu ludności w formacie R-markdown.
  * PUMS1.md : Plik PUMS1.Rmd w formacie markdown.
  * psub.RDS : Dane uzyskane za pomocą pliku PUMS1.Rmd.



## Licencja obejmująca dodatkowe dokumentację, uwagi, kod i dane pochodne: 

<a rel="license" href="https://creativecommons.org/licenses/by-nc-sa/4.0/deed.pl"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-nc-sa/4.0/88x31.png" /></a><br />Niniejsze dzieło jest objęte licencją <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/">Uznanie autorstwa - Użycie niekomercyjne - Na tych samych warunkach 4.0 Międzynarodowe</a>.

Żaden z tych elementów nie jest objęty gwarancją, ubezpieczeniem ani roszczeniem działania.

Licencja nie obejmuje projektów osób trzeci ani danych pochodnych.

