

# Przykładowe kod i dane współtowarzyszące książce "Język R i analiza danych w praktyce. Wydanie II" autorstwa Niny Zumel i Johna Mounta, Helion 2021.


 * Książka (wersja angielska): ["Practical Data Science with R, 2nd Edition" autorstwa Niny Zumel i Johna Mounta, Manning 2019](http://practicaldatascience.com/) (prawa autorskie należą do wydawnictwa Manning Publications Co.; wszystkie prawa zastrzeżone)
 * Strona z materiałami dodatkowymi (wersja oryginalna): [GitHub WinVector/PDSwR2](https://github.com/WinVector/PDSwR2)


## Fragment książki, dla którego przeznaczone są zawarte w tym katalogu kod i dane:
 * Rozdział 9. Metody nienadzorowane


Pierwotne źródło danych: http://lib.stat.cmu.edu/DASL/Datafiles/Protein.html
Autoryzacja: Swobodny użytek

Pochodne źródła danych
protein.txt     : bezpośrednia kopia pierwotnych danych

Wczytanie danych:
protein <- read.table('protein.txt', header=T, sep='\t')

Literatura: Weber, A. (1973) Agrarpolitik im Spannungsfeld der internationalen Ernaehrungspolitik, Institut fuer Agrarpolitik und marktlehre, Kiel. 
Dane te występują także w: Gabriel, K.R. (1981) Biplot display of multivariate matrices for inspection of data and diagnosis. 
In Interpreting Multivariate Data (Ed. V. Barnett), New York: John Wiley & Sons, 147-173. Hand, D.J., et al. (1994) A Handbook of Small Data Sets, London: Chapman & Hall, 297-298.

Opis: Dane te mierzą spożycie białek (podzielonych na dziewięć grup) w 25 krajach europejskich. Mozliwe jest używanie metod wielowymiarowych w celu określenia występowania grup państw o podobnych nawykach żywieniowych, a także czy spożycie mięsa jest w jakiś sposób powiązane ze spożywaniem innych pokarmów.

Liczba przypadków: 25
Nazwy zmiennych:
Country: nazwa kraju
RdMeat: mięso czerwone
WhMeat: mięso białe
Eggs: jajka
Milk: mleko
Fish: ryby
Cereal: płatki śniadaniowe
Starch: pokarmy skrobiowe
Nuts: rośliny strączkowe, orzechy i nasiona oleiste
Fr&Veg: owoce i warzywa


## Licencja obejmująca dodatkowe dokumentację, uwagi, kod i dane pochodne: 

<a rel="license" href="https://creativecommons.org/licenses/by-nc-sa/4.0/deed.pl"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-nc-sa/4.0/88x31.png" /></a><br />Niniejsze dzieło jest objęte licencją <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/">Uznanie autorstwa - Użycie niekomercyjne - Na tych samych warunkach 4.0 Międzynarodowe</a>.

Żaden z tych elementów nie jest objęty gwarancją, ubezpieczeniem ani roszczeniem działania.

Licencja nie obejmuje projektów osób trzecich ani danych pochodnych.
